'''
Copyright: ZopeChina Corp, Ltd. http://zopechina.com
'''

from Products.CMFCollector.Collector import CollectorCatalog
from Products.CMFCore.CatalogTool import CatalogTool

class Empty: pass

def CollectorCatalog_init(self):
        CatalogTool.__init__(self)
        # modify the catalog for chinese index

        # delete the TextIndex
        self.delIndex('version_info')

        # add index
        title_extras = Empty()
        title_extras.doc_attr = 'version_info'
        title_extras.index_type = 'Okapi BM25 Rank'
        title_extras.lexicon_id = 'CJKLexicon'
        self.addIndex('version_info', 'ZCTextIndex', title_extras)

CollectorCatalog.__init__ = CollectorCatalog_init
