'''
PloneĲ

Ȩ
ZopeChina.com
Ϻ׿Ϣι˾
'''

'''
1. ޸plonecatalog_toolTextIndexΪ֧ĵZCTextIndex, ʹCJKSPlitter.
'''
import os
from Products.CMFPlone.PloneUtilities import log

from Products.ZCTextIndex import ZCTextIndex
from Products.CMFCore.CatalogTool import CatalogTool
from Products.CMFDefault import utils
import re, os

from Products.ZCatalog.ZCatalog import ZCatalog

class Empty: pass

def CatalogToolWithZCIndex__init(self):
        ZCatalog.__init__(self, self.getId())
        self._initIndexes()

        # delete the TextIndex
        self.delIndex('Title')
        self.delIndex('Description')
        self.delIndex('SearchableText') 

        # add Lexicon
        elem = []
        wordSplitter = Empty()
        wordSplitter.group = 'Word Splitter'
        wordSplitter.name = 'CJK splitter'

        caseNormalizer = Empty()
        caseNormalizer.group = 'Case Normalizer'
        caseNormalizer.name = 'Case Normalizer'

        stopWords = Empty()
        stopWords.group = 'Stop Words'
        stopWords.name = 'Remove listed and single char words'

        elem.append(wordSplitter)
        elem.append(caseNormalizer)
        elem.append(stopWords)
        ZCTextIndex.manage_addLexicon(self, 'CJKLexicon', 'Default Lexicon', elem)

        # add index
        title_extras = Empty()
        title_extras.doc_attr = 'Title'
        title_extras.index_type = 'Okapi BM25 Rank'
        title_extras.lexicon_id = 'CJKLexicon'
        self.addIndex('Title', 'ZCTextIndex', title_extras)

        title_extras = Empty()
        title_extras.doc_attr = 'Description'
        title_extras.index_type = 'Okapi BM25 Rank'
        title_extras.lexicon_id = 'CJKLexicon'
        self.addIndex('Description', 'ZCTextIndex', title_extras)

        title_extras = Empty()
        title_extras.doc_attr = 'SearchableText'
        title_extras.index_type = 'Okapi BM25 Rank'
        title_extras.lexicon_id = 'CJKLexicon'
        self.addIndex('SearchableText', 'ZCTextIndex', title_extras)

CatalogTool.__init__ = CatalogToolWithZCIndex__init

'''
2. ޸ploneıΪutf8
'''
from Products.CMFPlone.CustomizationPolicy import DefaultCustomizationPolicy
from OFS.PropertyManager import PropertyManager
from Products.CMFPlone.Portal import addPolicy
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.Expression import Expression
from Products.CMFCore import CMFCorePermissions

def addSiteProperties(self, portal):
        """ adds site_properties in portal_properties """
        id='site_properties'
        title='Site wide properties'
        p=PropertyManager('id')
        if id not in portal.portal_properties.objectIds():
            portal.portal_properties.addPropertySheet(id, title, p)
            
        p=getattr(portal.portal_properties, id)
        
        #Now we add the lagniappe
        if not hasattr(p,'allowAnonymousViewAbout'): p._setProperty('allowAnonymousViewAbout', 1, 'boolean')
        if not hasattr(p,'localTimeFormat'): p._setProperty('localTimeFormat', '%Y-%m-%d', 'string')
        if not hasattr(p,'localLongTimeFormat'): p._setProperty('localLongTimeFormat', '%Y-%m-%d %I:%M %p', 'string')
        if not hasattr(p,'default_language'): p._setProperty('default_language', 'zh', 'string')
        if not hasattr(p,'default_charset'): p._setProperty('default_charset', 'utf-8', 'string')
        if not hasattr(p,'use_folder_tabs'): p._setProperty('use_folder_tabs',('Folder',), 'lines')
        if not hasattr(p,'use_folder_contents'): p._setProperty('use_folder_contents',('Folder',), 'lines')
        if not hasattr(p,'ext_editor'): p._setProperty('ext_editor', 0, 'boolean')
        if not hasattr(p, 'available_editors'): 
            p._setProperty('available_editors', ('None', ), 'lines')
        if not hasattr(p, 'allowRolesToAddKeywords'): p._setProperty('allowRolesToAddKeywords', ['Manager', 'Reviewer'], 'lines')


DefaultCustomizationPolicy.addSiteProperties =  addSiteProperties

'''
3. ޸֧windows External Editor֧
'''
def parseHeadersBody( body, headers=None, rc=re.compile( r'\n|\r\n' ) ):
    # Split the lines apart, taking into account Mac|Unix|Windows endings
    lines = rc.split(body)

    i = 0
    if headers is None:
        headers = {}
    else:
        headers = headers.copy()

    hdrlist = []

    for line in lines:

        if not line.strip():
            break

        tokens = line.split( ': ' )

        if len( tokens ) > 1:
            hdrlist.append( ( tokens[0], ': '.join( tokens[1:] ) ) )
        elif i == 0:
            return headers, body     # no headers, just return those passed in.
        else:    # continuation
            last, hdrlist = hdrlist[ -1 ], hdrlist[ :-1 ]
            hdrlist.append( ( last[ 0 ]
                            , '\n'.join( ( last[1], line.lstrip() ) )
                            ) )
        i = i + 1

    for hdr in hdrlist:
        headers[ hdr[0] ] = hdr[ 1 ]

    return headers, '\r\n'.join( lines[ i+1: ] )  #  Zopechina change this line only!!

utils.parseHeadersBody = parseHeadersBody

'''
ȥ
'''
def formatRFC822Headers( headers ):

    """ Convert the key-value pairs in 'headers' to valid RFC822-style
        headers, including adding leading whitespace to elements which
        contain newlines in order to preserve continuation-line semantics.
    """
    munged = []
    #linesplit = re.compile( r'[\n\r]+?' )
    linesplit = re.compile( r'[\n\r]+?\s*' )  #Zopechina

    for key, value in headers:

        #vallines = linesplit.split( value )
        vallines = linesplit.split( value.rstrip() )  # ZopeChina
        munged.append( '%s: %s' % ( key, '\r\n  '.join( vallines ) ) )

    return '\r\n'.join( munged )

utils.formatRFC822Headers = formatRFC822Headers
